Index: trunk/include/helpers/apps.h
===================================================================
--- trunk/include/helpers/apps.h	(revision 125)
+++ trunk/include/helpers/apps.h	(revision 127)
@@ -103,5 +103,7 @@
                                     const PROGDETAILS *pcProgDetails,
                                     ULONG ulFlags,
-                                    HAPP *phapp);
+                                    HAPP *phapp,
+                                    ULONG cbFailingName,
+                                    PSZ pszFailingName);
 
         BOOL XWPENTRY appWaitForApp(HWND hwndNotify,
Index: trunk/include/helpers/comctl.h
===================================================================
--- trunk/include/helpers/comctl.h	(revision 125)
+++ trunk/include/helpers/comctl.h	(revision 127)
@@ -411,4 +411,13 @@
                 // caused by a mouse click.
     } EMPHASISNOTIFY, *PEMPHASISNOTIFY;
+
+    /* ******************************************************************
+     *
+     *   Super Combo Box
+     *
+     ********************************************************************/
+
+    BOOL ctlComboFromEntryField(HWND hwnd,
+                                ULONG flStyle);
 
     /* ******************************************************************
Index: trunk/include/helpers/dosh.h
===================================================================
--- trunk/include/helpers/dosh.h	(revision 125)
+++ trunk/include/helpers/dosh.h	(revision 127)
@@ -345,19 +345,8 @@
                            ULONG ulAttr);
 
-    APIRET doshOpenExisting(PCSZ pcszFilename,
+    /* APIRET doshOpenExisting(PCSZ pcszFilename,
                             ULONG ulOpenFlags,
                             HFILE *phf);
-
-    APIRET doshWriteAt(HFILE hf,
-                       LONG lOffset,
-                       ULONG ulMethod,
-                       ULONG cb,
-                       PBYTE pbData);
-
-    APIRET doshReadAt(HFILE hf,
-                      LONG lOffset,
-                      ULONG ulMethod,
-                      PULONG pcb,
-                      PBYTE pbData);
+       */
 
     /*
@@ -377,6 +366,7 @@
 
     #define XOPEN_READ_EXISTING           0x0001
-    #define XOPEN_READWRITE_APPEND        0x0002
-    #define XOPEN_READWRITE_NEW           0x0003
+    #define XOPEN_READWRITE_EXISTING      0x0002
+    #define XOPEN_READWRITE_APPEND        0x0003
+    #define XOPEN_READWRITE_NEW           0x0004
     #define XOPEN_ACCESS_MASK             0xffff
 
@@ -388,7 +378,17 @@
                     PXFILE *ppFile);
 
+    APIRET doshReadAt(PXFILE pFile,
+                      ULONG ulOffset,
+                      PULONG pcb,
+                      PBYTE pbData);
+
     APIRET doshWrite(PXFILE pFile,
-                     PCSZ pcsz,
-                     ULONG cb);
+                     ULONG cb,
+                     PCSZ pbData);
+
+    APIRET doshWriteAt(PXFILE pFile,
+                       ULONG ulOffset,
+                       ULONG cb,
+                       PCSZ pbData);
 
     APIRET doshWriteLogEntry(PXFILE pFile,
@@ -858,5 +858,6 @@
     #define EXEFORMAT_LX            4
     #define EXEFORMAT_TEXT_BATCH    5
-    #define EXEFORMAT_TEXT_REXX     6
+    #define EXEFORMAT_TEXT_CMD      6       // REXX or plain OS/2 batch
+    #define EXEFORMAT_COM           7       // added V0.9.16 (2002-01-04) [umoeller]
 
     // target OS (in NE and LX)
@@ -869,4 +870,8 @@
     #define EXEOS_WIN32             6
 
+#ifndef __STRIP_DOWN_EXECUTABLE__
+// for mini stubs in warpin, which has its own
+// implementation of this
+
     /*
      *@@ EXECUTABLE:
@@ -877,5 +882,6 @@
     typedef struct _EXECUTABLE
     {
-        HFILE               hfExe;
+        // executable opened by doshOpen
+        PXFILE              pFile;
 
         /* All the following fields are set by
@@ -891,8 +897,6 @@
 
         // New Executable (NE) header, if ulExeFormat == EXEFORMAT_NE
-#ifndef __STRIP_DOWN_EXECUTABLE__       // for mini stubs in warpin, to reduce code size
         PNEHEADER           pNEHeader;
         ULONG               cbNEHeader;
-#endif
 
         // Linear Executable (LX) header, if ulExeFormat == EXEFORMAT_LX
@@ -901,8 +905,7 @@
 
         // Portable Executable (PE) header, if ulExeFormat == EXEFORMAT_PE
-#ifndef __STRIP_DOWN_EXECUTABLE__       // for mini stubs in warpin, to reduce code size
         PPEHEADER           pPEHeader;
         ULONG               cbPEHeader;
-#endif
+
         // module analysis (always set):
         ULONG               ulExeFormat;
@@ -913,5 +916,6 @@
                 // EXEFORMAT_LX            4
                 // EXEFORMAT_TEXT_BATCH    5
-                // EXEFORMAT_TEXT_REXX     6
+                // EXEFORMAT_TEXT_CMD      6
+                // EXEFORMAT_COM           7
 
         BOOL                fLibrary,           // TRUE if this is a DLL
@@ -942,5 +946,4 @@
                 // module info substring (if IBM BLDLEVEL format)
 
-#ifndef __STRIP_DOWN_EXECUTABLE__       // for mini stubs in warpin, to reduce code size
         // if pszInfo is extended DESCRIPTION field, the following
         // are set as well:
@@ -964,6 +967,4 @@
         POS2NERESTBLENTRY       paOS2NEResTblEntry;
         POS2NESEGMENT           paOS2NESegments;
-
-#endif
     } EXECUTABLE, *PEXECUTABLE;
 
@@ -1061,4 +1062,5 @@
                               PCSZ *papcszExtensions,
                               ULONG cExtensions);
+#endif
 
     /********************************************************************
@@ -1264,4 +1266,13 @@
     VOID doshFreeLVMInfo(PLVMINFO pInfo);
 
+    /* ******************************************************************
+     *
+     *   Wildcard matching
+     *
+     ********************************************************************/
+
+    BOOL doshMatch(const char *pcszMask,
+                   const char *pcszName);
+
 #endif
 
Index: trunk/include/helpers/gpih.h
===================================================================
--- trunk/include/helpers/gpih.h	(revision 125)
+++ trunk/include/helpers/gpih.h	(revision 127)
@@ -270,8 +270,4 @@
     HBITMAP XWPENTRY gpihCreateBitmap2(HPS hpsMem, ULONG  cx, ULONG cy, ULONG cPlanes, ULONG cBitCount);
 
-    HBITMAP XWPENTRY gpihCreateBmpFromPS(HAB hab, HPS hpsScreen, PRECTL prcl);
-    typedef HBITMAP XWPENTRY GPIHCREATEBMPFROMPS(HAB hab, HPS hpsScreen, PRECTL prcl);
-    typedef GPIHCREATEBMPFROMPS *PGPIHCREATEBMPFROMPS;
-
     HBITMAP XWPENTRY gpihCreateHalftonedBitmap(HAB hab, HBITMAP hbmSource, LONG lColorGray);
     typedef HBITMAP XWPENTRY GPIHCREATEHALFTONEDBITMAP(HAB hab, HBITMAP hbmSource, LONG lColorGray);
@@ -344,4 +340,8 @@
     typedef GPIHDESTROYXBITMAP *PGPIHDESTROYXBITMAP;
 
+    PXBITMAP gpihCreateBmpFromPS(HAB hab,
+                                 HPS hpsScreen,
+                                 PRECTL prcl);
+
 #endif
 
Index: trunk/include/helpers/stringh.h
===================================================================
--- trunk/include/helpers/stringh.h	(revision 125)
+++ trunk/include/helpers/stringh.h	(revision 127)
@@ -166,33 +166,4 @@
     /* ******************************************************************
      *
-     *   Wildcard matching
-     *
-     ********************************************************************/
-
-    #define FNM_MATCH           0
-    #define FNM_NOMATCH         1
-    #define FNM_ERR             2
-
-    #define FNM_NOESCAPE        16
-    #define FNM_PATHNAME        32
-    #define FNM_PERIOD          64
-
-    #define FNM_STYLE_MASK      15
-
-    #define FNM_POSIX           0
-    #define FNM_OS2             1
-    #define FNM_DOS             2
-
-    #define FNM_IGNORECASE      128
-    #define FNM_PATHPREFIX      256
-
-    BOOL XWPENTRY strhMatchOS2(const char *pcszMask, const char *pcszName);
-
-    BOOL XWPENTRY strhMatchExt(const char *pcszMask,
-                               const char *pcszName,
-                               unsigned flags);
-
-    /* ******************************************************************
-     *
      *   Fast string searches
      *
Index: trunk/include/helpers/undoc.h
===================================================================
--- trunk/include/helpers/undoc.h	(revision 125)
+++ trunk/include/helpers/undoc.h	(revision 127)
@@ -113,22 +113,4 @@
     #define ID_WPMI_REFRESH                0x1F7
 
-    /*
-     * Return codes for wpConfirmObjectTitle:
-     *      only def'd in the Warp 4 Toolkit
-     *      (and partly in wpsystem.h).
-     */
-
-    #ifndef NAMECLASH_CANCEL
-        #define NAMECLASH_CANCEL    0
-    #endif
-    #ifndef NAMECLASH_NONE
-        #define NAMECLASH_NONE      1
-    #endif
-    #ifndef NAMECLASH_RENAME
-        #define NAMECLASH_RENAME    2
-    #endif
-    #ifndef NAMECLASH_REPLACE
-        #define NAMECLASH_REPLACE   8
-    #endif
 #endif
 
Index: trunk/include/helpers/winh.h
===================================================================
--- trunk/include/helpers/winh.h	(revision 125)
+++ trunk/include/helpers/winh.h	(revision 127)
@@ -534,5 +534,5 @@
 
     #define winhQueryLboxSelectedItem(hwndListBox, sItemStart) \
-            (SHORT)(WinSendMsg(hwndListBox,                    \
+            SHORT1FROMMR(WinSendMsg(hwndListBox,                    \
                             LM_QUERYSELECTION,                 \
                             (MPARAM)(sItemStart),              \
Index: trunk/include/helpers/wphandle.h
===================================================================
--- trunk/include/helpers/wphandle.h	(revision 125)
+++ trunk/include/helpers/wphandle.h	(revision 127)
@@ -56,4 +56,5 @@
     #define ERROR_WPH_NO_MATCHING_DRIVE_BLOCK       (ERROR_WPH_FIRST +  11)
     #define ERROR_WPH_NO_MATCHING_ROOT_DIR          (ERROR_WPH_FIRST +  12)
+    #define ERROR_WPH_NOT_FILESYSTEM_HANDLE         (ERROR_WPH_FIRST +  13)
 
     /* ******************************************************************